using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CsNetAp
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// URL情報を取得するDataTable
        /// </summary>
        private DataTable dtUrl = null;

        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// ボタンの処理(取得、再取得、中止)
        /// </summary>
        /// <param name="sender">sender</param>
        /// <param name="e">e</param>
        private void Button_Click(object sender, EventArgs e)
        {
            if (sender == Button3)
            {
                // 中止ボタン
                NonUrlCheck.UrlCheckClass.CancelFlag = true;
                return;
            }
            else if (sender == Button1)
            {
                // 取得ボタン
                dtUrl = null;
            }
            else if (sender == Button2)
            {
                // 再取得ボタン(取得ボタンで中止やエラーになったURLの再チェック)
            }

            // 進捗状況表示
            Label1.Text = "0 / 0";

            // ボタン制御
            Button1.Enabled = false;
            Button2.Enabled = false;
            Button3.Enabled = true;
            Button3.Focus();

            // 処理中止フラグ
            NonUrlCheck.UrlCheckClass.CancelFlag = false;

            // ライセンスキー(URL解析階層数に2以上を設定する場合に必要)
            // 評価期間(最大１ヶ月)はライセンスキー無しでURL解析階層数を2以上に設定する事が可能
            NonUrlCheck.UrlCheckClass.LicenseKey = "";

            // URL解析する階層数(例:10)
            NonUrlCheck.UrlCheckClass.UrlLevel = 1;

            // デフォルトインデックス(例:"index.html")
            NonUrlCheck.UrlCheckClass.DefaultIndex = "index.html";

            // URLを解析するタグおよび属性
            // (例:"a,href,lnk", "form,action,lnk", "frame,src,lnk", "iframe,src,lnk",
            // "img,src,img", "body,background,img", "table,background,img", "tr,background,img", "td,background,img",
            // "script,src,etc", "link,href,etc")
            NonUrlCheck.UrlCheckClass.ChkUrTag = new String[] {
                "a,href,lnk", "form,action,lnk", "frame,src,lnk", "iframe,src,lnk", 
                "img,src,img", "body,background,img", "table,background,img", "tr,background,img", "td,background,img", 
                "script,src,etc", "link,href,etc"};

            // CGIと判定するファイルの拡張子(例:"cgi", "pl", "php", "asp", "aspx", "jsp")
            NonUrlCheck.UrlCheckClass.JdgCgiExt = new String[] {"cgi", "pl", "php", "asp", "aspx", "jsp"};

            // [?]を含むURLをCGIと判断するかどうか(例:True)
            NonUrlCheck.UrlCheckClass.JdgQstMrk = true;

            // URLを解析するContent-Type(文字列の一部)(例:"html", "css", "plain")
            NonUrlCheck.UrlCheckClass.ChkCnTyp = new String[] {"html", "css"};

            // CGI内部のURL解析をするかどうか(例:False)
            NonUrlCheck.UrlCheckClass.ChkCnTypCgi = false;

            // リンクとして分類するContent-Type(文字列の一部)(例:"html", "pdf", "plain", "excel", "word", "zip")
            NonUrlCheck.UrlCheckClass.LnkCnTyp = new String[] { "html", "pdf" };

            // CGIをリンクとして分類するかどうか(例:False)
            NonUrlCheck.UrlCheckClass.LnkCnTypCgi = false;

            // 外部URLを対象外とするかどうか(例:False)
            NonUrlCheck.UrlCheckClass.ChkNoOut = false;

            // 対象外ファイルやフォルダ(フォルダは/で終了)(例:"sitemap.html","bbs/")
            NonUrlCheck.UrlCheckClass.ChkNoFil = new String[] { };

            // WEBページのディスク保存フォルダ(例:"C:\Temp\Html")
            NonUrlCheck.UrlCheckClass.WebSaveFolder = "";

            // WWEBページ保存時に相対PATH変換(例:False)
            NonUrlCheck.UrlCheckClass.SaveRelPath = false;

            // URL取得処理間隔(秒)(例:0.1)
            NonUrlCheck.UrlCheckClass.WebThreadSlp = 0.1;

            // URL取得同時処理数(例:10)
            NonUrlCheck.UrlCheckClass.WebThreadNum = 4;

            // WEB受信タイムアウト時間(秒)(例:15)
            NonUrlCheck.UrlCheckClass.WebTimeout = 15;

            // プロキシサーバー(例:"localhost:8080"または"user:pass@localhost:8080")
            NonUrlCheck.UrlCheckClass.ProxyServer = "";

            // 初期処理
            NonUrlCheck.UrlCheckClass.Initialize();

            // URL情報を取得するDataTable初期化
            dtUrl = NonUrlCheck.UrlCheckClass.InitDtUrl(TextBox1.Text, dtUrl);

            // サイト内全URL取得
            int idx = 0;
            while (idx < dtUrl.Rows.Count)
            {
                // 進捗状況表示
                Label2.Text = dtUrl.Rows[idx]["Url"].ToString();

                // サイト内全URL取得(1URLづつ解析)
                NonUrlCheck.UrlCheckClass.GetAllUrl(dtUrl, ref idx);
                idx += 1;

                // 進捗状況表示
                Label1.Text = idx + " / " + dtUrl.Rows.Count;
            }

            // 終了処理
            Label2.Text = "終了処理中...";
            Application.DoEvents();
            NonUrlCheck.UrlCheckClass.Terminate();

            // とりあえず再表示
            Label2.Text = "";
            Application.DoEvents();

            // ボタン制御
            Button1.Enabled = true;
            Button2.Enabled = true;
            Button3.Enabled = false;

            // URL一覧表示
            RadioButton1.Checked = false;
            RadioButton1.Checked = true;
        }

        /// <summary>
        /// ラジオボタンの処理
        /// </summary>
        /// <param name="sender">sender</param>
        /// <param name="e">e</param>
        private void RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            if (dtUrl == null) return;
            DataRow[] selRows = null;
            if(sender == RadioButton1 && RadioButton1.Checked){
                // 内部リンク
                selRows = dtUrl.Select("Typ = 'lnk' AND Out = '0'");
            }
            else if (sender == RadioButton2 && RadioButton2.Checked)
            {
                // 内部イメージ
                selRows = dtUrl.Select("Typ = 'img' AND Out = '0'");
            }
            else if (sender == RadioButton3 && RadioButton3.Checked)
            {
                // 内部その他
                selRows = dtUrl.Select("Typ = 'etc' AND Out = '0'");
            }
            else if (sender == RadioButton4 && RadioButton4.Checked)
            {
                // 外部リンク
                selRows = dtUrl.Select("Typ = 'lnk' AND Out = '1'");
            }
            else if (sender == RadioButton5 && RadioButton5.Checked)
            {
                // 外部イメージ
                selRows = dtUrl.Select("Typ = 'img' AND Out = '1'");
            }
            else if (sender == RadioButton6 && RadioButton6.Checked)
            {
                // 外部その他
                selRows = dtUrl.Select("Typ = 'etc' AND Out = '1'");
            }
            else if (sender == RadioButton7 && RadioButton7.Checked)
            {
                // エラー
                selRows = dtUrl.Select("Sts = '×'");
            }

            // URL一覧表示
            if (selRows != null)
            {
                DataGridView1.Rows.Clear();
                for (int i = 0; i <= selRows.Length - 1; i++)
                {
                    // URL一覧表示(1件づつ追加)
                    DataGridView1.Rows.Add();
                    DataGridView1.Rows[i].Cells["No"].Value = ("" + (i + 1));
                    DataGridView1.Rows[i].Cells["Url"].Value = selRows[i]["Url"].ToString();
                    DataGridView1.Rows[i].Cells["Dir"].Value = selRows[i]["Dir"].ToString();
                    DataGridView1.Rows[i].Cells["Ttl"].Value = selRows[i]["Ttl"].ToString();
                    DataGridView1.Rows[i].Cells["Typ"].Value = selRows[i]["Typ"].ToString();
                    DataGridView1.Rows[i].Cells["Out"].Value = selRows[i]["Out"].ToString();
                    DataGridView1.Rows[i].Cells["Lvl"].Value = selRows[i]["Lvl"].ToString();
                    DataGridView1.Rows[i].Cells["Frm"].Value = selRows[i]["Frm"].ToString();
                    DataGridView1.Rows[i].Cells["Sts"].Value = selRows[i]["Sts"].ToString();
                    DataGridView1.Rows[i].Cells["Err"].Value = selRows[i]["Err"].ToString();
                }
                // 件数表示
                Label1.Text = selRows.Length + " / " + dtUrl.Rows.Count;
                // ソート
                DataGridView1.Sort(Url, System.ComponentModel.ListSortDirection.Ascending);
            }
        }

        /// <summary>
        /// DataGridViewのソート処理
        /// </summary>
        /// <param name="sender">sender</param>
        /// <param name="e">e</param>
        private void DataGridView1_SortCompare(object sender, DataGridViewSortCompareEventArgs e)
        {
            if( e.Column.Name == "Url" || e.Column.Name == "No" )
            {
                String dir1 = DataGridView1.Rows[e.RowIndex1].Cells["Dir"].Value.ToString();
                String dir2 = DataGridView1.Rows[e.RowIndex2].Cells["Dir"].Value.ToString();
                e.SortResult = System.String.Compare(dir1, dir2, System.StringComparison.Ordinal);
                if (e.SortResult == 0)
                {
                    String url1 = DataGridView1.Rows[e.RowIndex1].Cells["Url"].Value.ToString();
                    String url2 = DataGridView1.Rows[e.RowIndex2].Cells["Url"].Value.ToString();
                    if (url1.LastIndexOf(NonUrlCheck.UrlCheckClass.DefaultIndex) ==
                        url1.Length - NonUrlCheck.UrlCheckClass.DefaultIndex.Length)
                    {
                        e.SortResult = -1;
                    }
                    else if (url2.LastIndexOf(NonUrlCheck.UrlCheckClass.DefaultIndex) ==
                        url2.Length - NonUrlCheck.UrlCheckClass.DefaultIndex.Length)
                    {
                        e.SortResult = +1;
                    }
                    else
                    {
                        e.SortResult = System.String.Compare(url1, url2, System.StringComparison.Ordinal);
                    }
                }
                e.Handled = true;
            }
            else
            {
                e.SortResult = System.String.Compare(
                    e.CellValue1.ToString(), e.CellValue2.ToString(), System.StringComparison.Ordinal);
                e.Handled = true;
            }
        }

        /// <summary>
        /// DataGridViewのソート完了時の処理
        /// </summary>
        /// <param name="sender">sender</param>
        /// <param name="e">e</param>
        private void DataGridView1_Sorted(object sender, EventArgs e)
        {
            for (int i = 0; i <= DataGridView1.Rows.Count - 1; i++)
            {
                DataGridView1.Rows[i].Cells["No"].Value = ("" + (i + 1));
            }
        }

        /// <summary>
        /// ボタンの処理(PageRank)
        /// </summary>
        /// <param name="sender">sender</param>
        /// <param name="e">e</param>
        private void button4_Click(object sender, EventArgs e)
        {
            String url = TextBox1.Text;
            if (DataGridView1.CurrentRow != null)
            {
                url = DataGridView1.CurrentRow.Cells["Url"].Value.ToString();
            }
            NonPageRank.PageRankClass.ProxyServer = "";
            String pr = NonPageRank.PageRankClass.GetPageRank(url);
            MessageBox.Show(url + "    " + "\n" + "\n" + "PageRank:" + pr);
        }
    }
}